# -*- coding: utf-8 -*-
"""
Created on Tue May 30 10:21:05 2017

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import range
from builtins import super
from builtins import str

from copy import copy
from .ruling import ruling
from random import randint

class ruleSequence(ruling):
    
    type = 'rule-sequence'
    
    def __init__(self, rules, quantifier = [1,1], matching = 'G', *args, **kwargs):
        super(ruleSequence, self).__init__()        
        self.rules = rules
        self.quantifier = quantifier
        self.matching = matching
        self.tempMax = None
        self.cycles = []
        self.lenS = []
        self.trace = None

        
    def apply(self, form, backtrace = False, s = [], random = True, *args, **kwargs):
        if not backtrace:
            self.lenS.append([len(s)])
            cycle = [form.duplicate()]
            if self.matching == self.PROBABILISTIC and self.quantifier[1] is not None:
                self.tempMax = randint(self.quantifier[0], self.quantifier[1])
            else:
                self.tempMax = self.quantifier[1]
        elif self.matching == 'PO':
            l = self.lenS.pop()[0]
            while len(s) > l:
                s.pop()
            self.printS(s)
            return False
        else:
            cycle = self.cycles.pop()
            if len(cycle) == 1:
                return False
            cycle.pop()


        while self.quantifier[1] is None or len(cycle)-1 < self.tempMax:

            if not backtrace:
                self.trace = 0
            else:
                self.trace = len(self.rules) - 1
            
            while self.trace < len(self.rules):
                if self.rules[self.trace].type == 'rule':
                    if backtrace:
                        s.pop()
                    self.printS(s)
                #print('\n__',self,backtrace, end='                  ')
                app = self.rules[self.trace].apply(form, backtrace = backtrace, s = s, random = random)
                if app is not False:
                    form = app
                    backtrace = False
                elif self.matching == 'PO':
                    if len(cycle) > self.quantifier[0]:
                        self.cycles.append(cycle)
                        l = self.lenS[-1][-1]
                        while len(s) > l:
                            s.pop()
                        return cycle[-1]
                    l = self.lenS.pop()[0]
                    while len(s) > l:
                        s.pop()
                    return False
                else:
                    if self.trace == 0:
                        if len(cycle) > self.quantifier[0]:
                            self.cycles.append(cycle)
                            return cycle[-1]
                        if len(cycle) == 1:
                            return False
                        cycle.pop()
                        self.trace = len(self.rules)
                        
                    self.trace -= 1
                    
                    backtrace = True
                    print('>>backtrace<<', end = '')
                    #print('>>>>==== BACKTRACE ====<<<<')
                    continue
                self.trace += 1
            
            self.lenS[-1].append(len(s))
            cycle.append(form.duplicate())
            
            if self.matching == self.PROBABILISTIC and self.quantifier[1] is None:
                if randint(0,1) == 0:
                    break
        self.cycles.append(cycle)
        return form
        
    def totalRules(self):
        ctrace = 0
        for i in range(len(self.rules)):
            if self.rules[i].type == 'rule':
                ctrace+=1
            else:
                ctrace+= self.rules[i].totalRules('max')
        return ctrace