# -*- coding: utf-8 -*-
"""
Created on Mon Nov  7 10:41:33 2016

@author: akibdpt
"""
from __future__ import division
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import absolute_import
from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from builtins import object
from ..struct.coordinate import c0p5
from ..struct.vector import vector2D, vector3D

class boundary():
    
    def __init__(self):
        self.canonical = []
        self.polygonal = []
    
    def __len__(self):
        return len(self.canonical)
    
    def __eq__(self, other):
        if len(self.canonical) != len(other.canonical):
            return False
        for i in self.canonical:
            check = False
            for j in other.canonical:
                if i == j:
                    check =True
            if check == False:
                return False
        return True
    
    def printRhino(self, displacement = 0):
        s = ''
        s+='_polyline '
        for j in self.polygonal:
            s += str(j.x + displacement) + ',' + str(j.y) + ' '
        s+= str(self.polygonal[0].x + displacement) + ',' + str(self.polygonal[0].y) + '\n '
        s+='_SelPolyline _PlanarSrf _Delete'
        
        return s 
    def add(self, obj):
        if obj.type == 'struct-vector2D' or obj.type == 'struct-vector3D':
            self.polygonal.append(obj)
        else:
            self.canonical.append(obj)
    
    def merge(self, other):
        self.canonical += other.canonical
        self.polygonal += other.polygonal
        
    def sort(self):
        self.canonical.sort()
    
    def partOf(self, other):
        raise ValueError()
        for i in self.canonical:
            check = False
            for j in other.canonical:
                if i == j or i.partOf(j):
                    check = True
            if check == False:
                return False
        return True
       
    def containsBoundary(self, other):
        otherCanon = []
        for line in other.canonical:
            otherCanon.append([line, 0])
        
        for point in other.polygonal:
            for oLines in otherCanon:
                if oLines[0].start == point or oLines[0].end == point:
                    oLines[1] += 1
            check = False
            for line in self.canonical:
                if line.containsPoint(point):
                    check = True
                    break
            if check:
                continue
            if not self.containsPointInside(point):
                return False
        for oLine in otherCanon:
            otherLine = oLine[0]

            if oLine[1] == 1:
                continue
            elif oLine[1] == 2:
                midp = otherLine.start.midpoint(otherLine.end)
                check = False
                for line in self.canonical:
                    if line.containsPoint(midp):
                        check = True
                        break
                if check:
                    continue
                if not self.containsPointInside(midp):
                    return False
                continue

            for line in self.canonical:
                if (line.direction.parallel(otherLine.direction)
                or line.start.colinear(otherLine.start, otherLine.end) 
                or line.end.colinear(otherLine.start, otherLine.end)
                or otherLine.start.colinear(line.start, line.end) 
                or otherLine.end.colinear(line.start, line.end)):
                    continue
                if self.intersect2D(line.start, line.end, otherLine.start, otherLine.end):
                    return False

        return True
        
    """
    def containsBoundary(self, other):
        for point in other.polygonal:
            check = False
            for line in self.canonical:
                if line.containsPoint(point):
                    check = True
                    break
            if check:
                continue
            if not self.containsPointInside(point):
                return False
                
        for line in self.canonical:
            for otherLine in other.canonical:
                if (line.direction.parallel(otherLine.direction)
                or line.start.colinear(otherLine.start, otherLine.end) 
                or line.end.colinear(otherLine.start, otherLine.end)
                or otherLine.start.colinear(line.start, line.end) 
                or otherLine.end.colinear(line.start, line.end)):
                    continue
                if self.intersect2D(line.start, line.end, otherLine.start, otherLine.end):
                    return False

        return True
    """    

    def containsPointInside(self, point):
        # assumption: point not on any border line of the boundary
        maxX = self.polygonal[0].x
        minX = self.polygonal[0].x
        maxY = self.polygonal[0].y
        minY = self.polygonal[0].y
        for i in self.polygonal:
            if maxX < i.x:
                maxX = i.x
            elif minX > i.x:
                minX = i.x
            if maxY < i.y:
                maxY = i.y
            elif minY > i.y:
                minY = i.y
        if minX > point.x or maxX < point.x or minY > point.y or maxY < point.y:
            return False
        start = point
        end = vector2D(point.x, maxY+1)
        intersectionCount = 0
        for i in self.canonical:
            if boundary.intersect2D(start, end, i.start, i.end):
                intersectionCount += 1
        if intersectionCount % 2 == 1:
            return True
        return False
        
            
    @staticmethod
    def ccw(A,B,C):
        return (C.y-A.y) * (B.x-A.x) > (B.y-A.y) * (C.x-A.x)
    
    # Return true if line segments AB and CD intersect
    @staticmethod
    def intersect2D(A, B, C, D):
        dir1 = B.subtract(A)
        dir2 = D.subtract(C)
        if dir1.parallel(dir2): 
            return False
        return boundary.ccw(A,C,D) != boundary.ccw(B,C,D) and boundary.ccw(A,B,C) != boundary.ccw(A,B,D)
    
    def maximalize(self):
        i = 1
        while i < len(self.canonical):
            if (self.canonical[i].start == self.canonical[i-1].end
            and self.canonical[i].start.colinear(self.canonical[i].end, self.canonical[i-1].start)):
                for j in self.polygonal:
                    if j == self.canonical[i].start:
                        self.polygonal.remove(j)
                        break
                newLine = bSegment(self.canonical[i-1].start, self.canonical[i].end)                
                self.canonical[i-1] = newLine
                self.canonical.pop(i)
                continue
            i+=1
        return
        
    def __iter__(self):
        return iter(self.canonical)
    
    def transform(self, matrix):
        result = boundary()
        for i in self.canonical:
            result.canonical.append(i.transform(matrix))
        for i in self.polygonal:
            result.polygonal.append(i.transform(matrix))
        minIndex = result.polygonal.index(min(result.polygonal))
        result.polygonal = result.polygonal[minIndex:] + result.polygonal[:minIndex]
        return result
        
    def graphTransform(self, graphTrans):
        result = boundary()
        for i in self.polygonal:
            check = graphTrans.transform(i)
            if check is False:
                return False
            result.polygonal.append(check)
        i = 1
        while i < len(result.polygonal):
            if result.polygonal[i] == result.polygonal[i-1]:
                result.polygonal.pop(i)
            else:
                i += 1
        for i in self.canonical:
            bs = i.graphTransform(graphTrans)
            if bs.start == bs.end:
                continue
            result.canonical.append(bs)
        return result
    
    def findFloatValue(self, other):
        for i in self.canonical:
            check = False
            for j in other.canonical:
                if i.start.vectorFloat == j.start and i.end.vectorFloat == j.end:
                    check = True
            if check == False:
                return False
        return True
        
    @staticmethod
    def parse(reader, sort):
        raise NotImplementedError
        
        
class bSegment(object):
    POS_X_INF = vector2D(1,0,True)
    POS_Y_INF = vector2D(0,1,True)
    NEG_Y_INF = vector2D(0,-1,True)
    
    POS_X_INF_3D = vector3D(1,0,0,True)
    POS_Y_INF_3D = vector3D(0,1,0,True)
    NEG_Y_INF_3D = vector3D(0,-1,0,True)
    
    INFINITE = -1
    CLOSED = 0
    OPEN = 1
    
    def __init__(self, start, end, assoc = None):
        self.type = 'struct-bSegment'
        if 'ind' in start.type or 'ind' in end.type:
            raise ValueError('start and end must be vectors')
        if start.compareValue(end) == 1:
            self.start = end
            self.end = start
        else:
            self.start = start
            self.end = end
        self.direction = self.end.subtract(self.start)
        self.assoc = assoc
        self.alignedPositive = False
        
    def __str__(self):
        return 'bs'+str(self.start)+str(self.end)
        
    def __repr__(self):
        return 'bs'+str(self.start)+str(self.end)
        
    def printRhino(self, string = '', displacement = 0):
        s = '_line '
        s+= self.start.printRhino().split(' ')[1]+' '+self.end.printRhino().split(' ')[1]
        return s
        
    def root(self):
        return self.start.subtract(self.direction.scale(self.start))
    
    def length(self):
        direction = self.end.subtract(self.start)
        return direction.dotproduct(direction) ** c0p5
        
    def squareLength(self):
        direction = self.end.subtract(self.start)
        return direction.dotproduct(direction)
        
    def isInfinite(self):
        return self.start.isInfinite() or self.end.isInfinite()
    
    def aligns(self, other):
        return (self.end.colinear(other.start, other.end) and 
                self.direction.parallel(other.direction))
                
    def partOf(self, other):
        return (self.end.colinear(other.start, other.end) and 
                self.direction.parallel(other.direction) and
                self.start >= other.start and self.end <= other.end)
                
    def complement(self, other):
        result = []
        if self.start < other.start and self.end > other.start:
            result.append(bSegment(self.start, other.start))
        if self.start < other.end and self.end > other.end:
            result.append(bSegment(other.end, self.end))
        return result
    
    def __eq__(self, other):
        if other is None or other.__class__ != self.__class__:
            return False
        return (self.start == other.start) and (self.end == other.end)
            
    def __lt__(self, other):
        return self.compareValue(other) == -1
        
    def __gt__(self, other):
        return self.compareValue(other) == 1
        
    def __le__(self, other):
        return self.compareValue(other) < 1
        
    def __ge__(self, other):
        return self.compareValue(other) > -1
    
    def compareValue(self, other):
        c = self.direction.unit().compareValue(other.direction.unit()) 
        if c != 0:
            return c
        c = self.root().compareValue(other.root()) 
        if c != 0:
            return c
        c = self.start.compareValue(other.start) 
        if c != 0:
            return c
        return self.end.compareValue(other.end) 
        
    def transform(self, matrix):
        return bSegment(self.start.transform(matrix), self.end.transform(matrix))
        
    def graphTransform(self, transf):
        return bSegment(transf.apply(self.start), transf.apply(self.end))
        
    def containsPoint(self, point):
        if self.start == point or self.end == point:
            return True
        if not point.colinear(self.start,self.end):
            return False
        if self.start.compareValue(point) < 1 and self.end.compareValue(point) > -1:
            return True
        elif self.start.compareValue(point) > -1 and self.end.compareValue(point) < 1:
            return True
        return False
    
    def intersection(self, other, type = CLOSED):
        if self.isInfinite() or other.isInfinite():
            return None
        dir1 = self.direction
        dir2 = other.direction

        if dir1.parallel(dir2): 
            return None

        cross = dir1.product(dir2)
        diff = other.start.subtract(self.start)
        
        if self.start.type == 'struct-vector2D' or self.start.type == 'struct-vector2Dfloat':
            par1 = diff.product(dir2) / cross
            par2 = diff.product(dir1) / cross
        else:
            denom = cross.dotproduct(cross)
            par1 = diff.product(dir2).dotproduct(cross) / denom
            par2 = diff.product(dir1).dotproduct(cross) / denom
            
        if (par2>=0 and par2<=1 and (type == bSegment.INFINITE or 
            (type == bSegment.CLOSED and par1 >= 0 and par1 <= 1) or
            (type == bSegment.OPEN and par1 > 0 and par1< 1))):
            return self.start.add(dir1.scale(par1))
        return None


    def intersectionLine(self, root, direction):
        selfUnit = self.direction.unit()
        otherUnit = direction.unit()
        selfRoot = self.root()
        denom = selfUnit.product(otherUnit)
        diff = root.subtract(selfRoot)
        numer1 = diff.product(otherUnit)
        if denom.x != 0:
            x = numer1.x/denom.x
        elif denom.y != 0:
            x = numer1.y/denom.y
        else:
            x = numer1.z/denom.z
        return selfRoot.add(selfUnit.scale(x))


     


